"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var gql_ast_helpers_1 = require("./gql-ast-helpers");
var gql_test_utils_1 = require("./gql-test-utils");
describe('isOperationType()', function () {
    it('should return true if the given document contains the matching operation definition', function () {
        var query = gql_test_utils_1.strToDocNodes("{ test }");
        expect(gql_ast_helpers_1.isOperationType('query')(gql_ast_helpers_1.getDefinitionNode(query[0]))).toBeTruthy();
        expect(gql_ast_helpers_1.isOperationType('mutation')(gql_ast_helpers_1.getDefinitionNode(query[0]))).toBeFalsy();
    });
});
describe('getOperationsOfType()', function () {
    it('should return all the operations of a given type', function () {
        var doc = gql_test_utils_1.strToDocNodes("\n    { name }\n    mutation {\n      doSomething(test: true)\n    }");
        expect(gql_ast_helpers_1.getOperationsOfType('query')(doc)).toEqual([doc[0]]);
        expect(gql_ast_helpers_1.getOperationsOfType('mutation')(doc)).toEqual([doc[1]]);
    });
});
describe('getOperationName()', function () {
    var query = gql_test_utils_1.strToDocNodes("\n    query Query1 {\n      test\n    }\n  ");
    expect(gql_ast_helpers_1.getOperationName(query[0])).toBe('Query1');
});
