import { DocumentNode } from 'graphql';
import { GraphQLLoaderOptions } from './loader-options';
export declare const ERROR_NO_ANONYMOUS_OPERATIONS = "Anonymous operations are not allowed";
export declare const ERROR_ONLY_ONE_ANON_OPERATION_ALLOWED = "Only one anonymous operation allowed per component";
export declare const ERROR_NO_MIXED_NAME_CASE = "Cannot have both a named and anonymous operation in a component";
export interface DocumentError {
    message: string;
    affected: DocumentNode[];
}
export declare const failWithError: (err: string) => never;
export declare const noAnonymousOperations: (gqlNodes: DocumentNode[], loaderOptions: GraphQLLoaderOptions) => Promise<{}>;
export declare const failOnMixedNamedCase: (gqlNodes: DocumentNode[]) => Promise<{}>;
export declare const failOnMultipleAnonymous: (gqlNodes: DocumentNode[]) => Promise<{}>;
export declare const verifyDocuments: (gqlNodes: DocumentNode[], loaderOptions: GraphQLLoaderOptions) => Promise<[{}, {}, {}]>;
