"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var validationError = function (context, loaderCallback) { return function (err) {
    if (err && typeof err !== 'string' && err.message && err.affected) {
        var message = err.message, affected = err.affected;
        var errMsg = '\t\n\n' +
            ("\t" + message + " (" + context.resourcePath + ")") +
            '\t\n\n' +
            '\tResolve these affected items:' +
            '\t\n\n' +
            affected
                .map(function (a) { return graphql_1.print(a); })
                .map(function (s) {
                return s
                    .split('\n')
                    .map(function (s2) { return '\t' + s2; })
                    .join('\n');
            })
                .join('\n');
        loaderCallback(new Error(errMsg));
    }
    else {
        loaderCallback(new Error(err));
    }
}; };
exports.default = validationError;
